//----------------------------------------------------------------------------
#ifndef TChildFormH
#define TChildFormH
//----------------------------------------------------------------------------
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>


#include "TData.h"
#include "TCluster.h"
#include "TFragment.h"

#include "TNode.h"
#include "TLink.h"
#include "TNetwork.h"

#include "TNodeDialog.h"
#include "TLinkDialog.h"



#define NODES_RESOURCE_USAGE_FACTOR     0.33
#define LINKS_RESOURCE_USAGE_FACTOR     0.66


const int MAX_SAMPLES = 100;
const int MAX_RUNS    = 10;

class TMainForm;

//----------------------------------------------------------------------------
class TChildForm : public TForm
{
__published:

	TGroupBox *NetworkGroupBox;
	TPaintBox *NetworkPaintBox;
	TLabel    *NetworkLabel;

	TGroupBox *FragmentsGroupBox;
	TPaintBox *FragmentsPaintBox;
	TLabel    *FragmentLabel;

	TGroupBox *ClustersGroupBox;
	TPaintBox *ClustersPaintBox;
	TLabel    *ClusterLabel;

	TGroupBox *ResponseGroupBox;
	TPaintBox *ResponsePaintBox;
	TGroupBox *ResourceGroupBox;
	TPaintBox *ResourcePaintBox;
	TTrackBar *TrackBar1;
	TTrackBar *TrackBar2;
	TTrackBar *TrackBar3;
	TTrackBar *TrackBar4;
	TTrackBar *TrackBar5;
	TTrackBar *TrackBar6;
	TTrackBar *TrackBar7;
	TTrackBar *TrackBar8;
	TTrackBar *TrackBar9;
	TTrackBar *TrackBar11;
	TTrackBar *TrackBar12;
	TTrackBar *TrackBar13;
	TTrackBar *TrackBar14;
	TTrackBar *TrackBar15;
	TTrackBar *TrackBar16;
	TTrackBar *TrackBar17;
	TTrackBar *TrackBar18;
	TTrackBar *TrackBar19;
    TProgressBar *ProgressBar1;
    TProgressBar *ProgressBar2;
    TProgressBar *ProgressBar3;
    TProgressBar *ProgressBar4;
    TProgressBar *ProgressBar5;
    TProgressBar *ProgressBar6;
    TProgressBar *ProgressBar7;
    TProgressBar *ProgressBar8;
    TProgressBar *ProgressBar9;
    TLabel *ResponseLabel;
    TTimer *MainTimer;
    TLabel *ResourceLabel;
    TLabel *soActivityLabel;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);

	void __fastcall NetworkPaintBoxClick(TObject *Sender);
	void __fastcall NetworkPaintBoxDblClick(TObject *Sender);
	void __fastcall NetworkPaintBoxMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall NetworkPaintBoxMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall NetworkPaintBoxMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall NetworkPaintBoxPaint(TObject *Sender);

	void __fastcall FragmentsPaintBoxClick(TObject *Sender);
	void __fastcall FragmentsPaintBoxDblClick(TObject *Sender);
	void __fastcall FragmentsPaintBoxMouseDown(TObject *Sender, TMouseButton Button,	TShiftState Shift, int X, int Y);
	void __fastcall FragmentsPaintBoxMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall FragmentsPaintBoxMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall FragmentsPaintBoxPaint(TObject *Sender);

	void __fastcall ClustersPaintBoxClick(TObject *Sender);
	void __fastcall ClustersPaintBoxDblClick(TObject *Sender);
	void __fastcall ClustersPaintBoxMouseDown(TObject *Sender, TMouseButton Button,	TShiftState Shift, int X, int Y);
	void __fastcall ClustersPaintBoxMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall ClustersPaintBoxMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall ClustersPaintBoxPaint(TObject *Sender);

	void __fastcall ResponsePaintBoxPaint(TObject *Sender);
	void __fastcall ResourcePaintBoxPaint(TObject *Sender);

	void __fastcall TrackBar1Change(TObject *Sender);
	void __fastcall TrackBar2Change(TObject *Sender);
	void __fastcall TrackBar3Change(TObject *Sender);
	void __fastcall TrackBar4Change(TObject *Sender);
	void __fastcall TrackBar5Change(TObject *Sender);
	void __fastcall TrackBar6Change(TObject *Sender);
	void __fastcall TrackBar7Change(TObject *Sender);
	void __fastcall TrackBar8Change(TObject *Sender);
	void __fastcall TrackBar9Change(TObject *Sender);
	void __fastcall MainTimerTimer(TObject *Sender);


    void __fastcall FormKeyPress(TObject *Sender, char &Key);
private:
	TNetwork*   backup_network;
    bool		to_be_undone;
    bool		to_be_redone;

	int			inside_node_index;
	int			inside_link_index;
	int      	inside_fragment_index;
	int      	inside_cluster_index;
    bool		dragging;
    bool		mouse_down;
	bool        left_mouse_button;
    bool	    right_mouse_button;
    bool		mouse_dblclk;

    TColor   	selection_color;

    int      	target_node_index;	// for migration or replication

	void		backup();
	void		undo();
	void		redo();

public:
    bool        auto_demands;
    bool        single_fragment;
    bool        same_demands_on_clusters;

    int         SO_FREQUENCY;
    int         P_FREQUENCY;        // partitioning
    int         M_FREQUENCY;        // migration
    int         C_FREQUENCY;        // combining
    int         R_FREQUENCY;        // replication
    int         D_FREQUENCY;        // destruction

    bool		running;
    int         running_counter;

    int         so_counter;
    int         p_counter;        // partitioning
    int         m_counter;        // migration
    int         c_counter;        // combining
    int         r_counter;        // replication
    int         d_counter;        // destruction
    int         so_activity[MAX_SAMPLES*MAX_RUNS];

    bool        p_enabled;        // partitioning
    bool        m_enabled;        // migration
    bool        c_enabled;        // combining
    bool        r_enabled;        // replication
    bool        d_enabled;        // destruction


public:
	TNetwork*   Network;

	bool	NoSelection();
	bool	ToBeUndone();
	bool	ToBeRedone();
	bool	Running();


	virtual __fastcall TChildForm(TComponent *Owner);

	void __fastcall FileNew();
	void __fastcall FileOpen();
	void __fastcall FileSave();
	void __fastcall FileSaveAs();
	void __fastcall FileClose();
	void __fastcall FilePrint();
	void __fastcall EditUndo();
	void __fastcall EditRedo();
	void __fastcall EditDelete();
	void __fastcall EditClear();
	bool __fastcall NetworkAddNode();
	bool __fastcall NetworkAddLink();
	void __fastcall RepositoryDataTypes();
	void __fastcall RepositoryStatistics();
	void __fastcall DomainProperties();
	void __fastcall RunStart();
	void __fastcall RunStop();
	void __fastcall RunEnableSO();
	void __fastcall RunDisableSO();
	void __fastcall OptionsFrequencies();
    void __fastcall OptionsThresholds();
    void __fastcall OptionsMigrationRules();
    void __fastcall OptionsReplicationRules();
};
//----------------------------------------------------------------------------
extern TChildForm*	ChildForm;
#endif

