//---------------------------------------------------------------------------
#ifndef TClusterH
#define TClusterH
//---------------------------------------------------------------------------
#include <stdlib.h>     // int random(int);


////////////////////////////////////////////////////////////////////////////////
//#define		MAX_CLUSTERS		10
#define		MAX_NODES			9
#define		MAX_LINKS			MAX_NODES * MAX_NODES


#define     MAX_FULLY_DEMANDING_NODES           6   // including local_node
////////////////////////////////////////////////////////////////////////////////



#include "TData.h"
class TFragment;

class TCluster
{
public:
 static int     scale;

//	double	    get_demand(int index)             	 { return demands[index];}
//	void	    set_demand(int index, double value)  { demands[index] = value; update_demands}

//private:        // private user declarations
public:
		int     demands[MAX_NODES];			// demand per node
		int     update_ratios[MAX_NODES];	// update/demand ratio per node
		int		update_ratio;				// average update ratio from all nodes


private:        // private user declarations
		int      id;
		TPoint   position;
		int      size; 		int radius;
		int      demand;	TColor   color;
        bool	 selected;
        TColor   selection_color;


public:         // public user declarations
	TFragment*		Fragment;

	TCluster(TCluster* _Cluster);
	TCluster(TFragment* _Fragment);
	virtual ~TCluster();

	int      get_id() 		     { return id;}
	TPoint   get_position()      { return position;}
	int		 get_size()      	 { return size;}
	int      get_radius()        { return radius;}
	int		 get_demand()   	 { return demand;}
	TColor   get_color()         { return color;}

	void set_id(int _id)	               	{ id        = _id;}
	void set_position(TPoint _position) 	{ position  = _position;}
   	void set_size(int _size);
	void update_demand();

    bool similar_in_demand_patterns_to(TCluster* _cluster); // for fragment partitioning

	void Draw(TCanvas* _canvas);
	void DrawCaption(TCanvas* _canvas);

	bool IsSelected();
    void Select(TColor _selection_color);
    void DeSelect();
};
//---------------------------------------------------------------------------
#endif
