////////////////////////////////////////////////////////////////////////////////
#ifndef TFuzzySystem_h
#define TFuzzySystem_h
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
#include "TFuzzyController.h"
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
#define	MAX_CONTROLLERS_PER_SYSTEM		16
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
class TFuzzySystem
{
  public:
    TFuzzyController*	controllers[MAX_CONTROLLERS_PER_SYSTEM];
	TFuzzySet*			output_sets[MAX_CONTROLLERS_PER_SYSTEM];
	double				outputs[MAX_CONTROLLERS_PER_SYSTEM];

  public:
	TFuzzySystem();
	virtual ~TFuzzySystem();


	void clear_controllers();
	void add_controller(TFuzzyController* controller);
	void remove_controller(TFuzzyController* controller);

	void clear_output_sets();
	void clear_outputs();

	void Run(
			  int aggregation_method=ZADEH,				// ZADEH, MEAN, ... PRODUCT, BONDEDSUM
              int correlation_method=TRUNCATE,			// TRUNCATE, SCALE
   			  int alphaCut_type=STRONG,					// STRONG, WEAK
              int composition_method=ZADEH,				// ZADEH, MEAN, ... PRODUCT, BONDEDSUM
              int defuzzification_method=CENTROID 		// CENTROID, MAXIMUM_HIGHT, ...
			);
};
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
#endif
////////////////////////////////////////////////////////////////////////////////

