//---------------------------------------------------------------------------
#ifndef TLinkH
#define TLinkH
//---------------------------------------------------------------------------
#include <vcl\Graphics.hpp>

#define LAN		0
#define WAN		1

#define MAX_FULLY_DEMANDED_FULLY_POPULATED_NODES_SERVICED_PER_FULL_CAPACITY_LINK   (5+5) // traffic in both ways



class TNetwork;
class TNode;


class TLink
{
    public:
		static int   scale;
		static int   serial_num;

    private:
		int      id;
		int      type;
		int      delay;         float    initial_delay;
		int      capacity;		int      width;
		float    utilization;	TColor   color;
        bool	 selected;
		TColor   selection_color;

		// calculate selection region around the link as nodes move
		TPoint*  calculateSelectionBoundary();

		// private fuctions used by    bool contains(TPoint _p);
    	bool     insideRect(TRect* r, TPoint p);
	    TRect*   calculateBounds(int xpoints[], int ypoints[], int npoints);

    public:
		TNetwork*		Network;
	    TNode*			Node_a;
		TNode*			Node_b;

	    TLink(TLink* _link);
	    TLink(TNetwork*	_Network, TNode* _node_a, TNode* _node_b);
	    virtual ~TLink();

		int		get_id()                { return id;}
		int     get_type()    			{ return type;}
		int     get_initial_delay()		{ return initial_delay;}
		int     get_delay()   			{ return delay;}
   		int  	get_capacity()          { return capacity;}
		int     get_width()    			{ return width;}
		float   get_utilization() 	    { return utilization;}
		TColor  get_color()    			{ return color;}

		void set_id(int _id)					    { id   	        = _id;}
		void set_type(int _type)				    { type 	        = _type;}
		void set_initial_delay(int _initial_delay)	{ initial_delay	= _initial_delay;
                                                      delay         = _initial_delay;
                                                    }
		void set_capacity(int _capacity);
		void set_utilization(float _utilization);     // also set_delay

		void Draw(TCanvas* _canvas);
		void DrawCaption(TCanvas* _canvas);
		void DrawDetails(TCanvas* _canvas);

		bool IsSelected();
	    void Select(TColor _selection_color);
	    void DeSelect();

		bool Contains(TPoint _p);
};

//---------------------------------------------------------------------------
#endif

