//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "TLinkDialog.h"


//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TLinkDialog *LinkDialog;   // auto-create

//---------------------------------------------------------------------------
__fastcall TLinkDialog::TLinkDialog(TComponent* Owner)
	: TForm(Owner)
{
	Link			= NULL;
	node_a_index	= -1;
	node_b_index	= -1;
}
//---------------------------------------------------------------------------
void __fastcall TLinkDialog::Node_a_ComboBoxChange(TObject *Sender)
{
	if (Node_a_ComboBox->ItemIndex != Node_b_ComboBox->ItemIndex)
    {
		node_a_index	= Node_a_ComboBox->ItemIndex;
    }
    else
    {
		Node_a_ComboBox->ItemIndex = -1;
    }
}
//---------------------------------------------------------------------------
void __fastcall TLinkDialog::Node_b_ComboBoxChange(TObject *Sender)
{
	if (Node_b_ComboBox->ItemIndex != Node_a_ComboBox->ItemIndex)
    {
		node_b_index	= Node_b_ComboBox->ItemIndex;
    }
    else
    {
		Node_b_ComboBox->ItemIndex = -1;
    }
}
//---------------------------------------------------------------------------
void __fastcall TLinkDialog::TypeComboBoxChange(TObject *Sender)
{
//
}
//---------------------------------------------------------------------------
void __fastcall TLinkDialog::DelayScrollBarChange(TObject *Sender)
{
	DelayPositionLabel->Caption = AnsiString(DelayScrollBar->Position) + AnsiString("%");
}
//---------------------------------------------------------------------------
void __fastcall TLinkDialog::CapacityScrollBarChange(TObject *Sender)
{
	CapacityPositionLabel->Caption = AnsiString(CapacityScrollBar->Position) + AnsiString("%");
}
//---------------------------------------------------------------------------
void __fastcall TLinkDialog::UpdateUtilization(int _utilization)
{
//    if (_utilization ==  0) _utilization =   0;
//    if (_utilization > 100) _utilization = 100;
	if (_utilization < 50)	//  0 .. 50
    {
       UtilizationShape->Brush->Color	= (TColor) RGB(
   											255 - (_utilization*2)*2.55,
	                            	        255 - (_utilization*2)*2.55,
	                                	    255
	            						  );
    }
    else	//  50 .. 100
    {
       UtilizationShape->Brush->Color	= (TColor) RGB(
	            							0,
       				            	        0,
                       					    ((100-_utilization)*2)*2.55
	            						  );
    }

	UtilizationPositionLabel->Caption = AnsiString(_utilization) + AnsiString("%");
}



//---------------------------------------------------------------------------
void __fastcall TLinkDialog::FormShow(TObject *Sender)
{
	if (Link != NULL)
    {
		node_a_index = Link->Network->Nodes->IndexOf(Link->Node_a);
		node_b_index = Link->Network->Nodes->IndexOf(Link->Node_b);

		Node_a_ComboBox->Clear();
	    for(int i=0; i<Link->Network->Nodes->Count; i++)
	    {
			Node_a_ComboBox->Items->Add(IntToStr((int) ((TNode*)Link->Network->Nodes->Items[i])->get_id() ));
		}
		Node_a_ComboBox->ItemIndex = node_a_index;

		Node_b_ComboBox->Clear();
    	for(int i=0; i<Link->Network->Nodes->Count; i++)
	    {
			Node_b_ComboBox->Items->Add(IntToStr((int) ((TNode*)Link->Network->Nodes->Items[i])->get_id() ));
		}
		Node_b_ComboBox->ItemIndex = node_b_index;

		TypeComboBox->ItemIndex = Link->get_type();
	    DelayScrollBar->Position = Link->get_initial_delay();
    	CapacityScrollBar->Position = Link->get_capacity();
        UpdateUtilization(Link->get_utilization());
    }
    else    // for adding new links
    {
	    DelayScrollBar->Position = 25;
    	CapacityScrollBar->Position = 50;
        UpdateUtilization(0);
    }
}
//---------------------------------------------------------------------------
void __fastcall TLinkDialog::OkBitBtnClick(TObject *Sender)
{
	if (Link != NULL)
    {
		if ( (Node_a_ComboBox->ItemIndex != -1) && (Node_b_ComboBox->ItemIndex != -1) )
    	{
	        ModalResult = mrOk;
			Link->Node_a = (TNode*)Link->Network->Nodes->Items[node_a_index];
			Link->Node_b = (TNode*)Link->Network->Nodes->Items[node_b_index];
			Link->set_type(TypeComboBox->ItemIndex);
	        Link->set_initial_delay(DelayScrollBar->Position);
        	Link->set_capacity(CapacityScrollBar->Position);
	    }
    	else
	    {
    	    ModalResult = mrNone;
	    }
    }
}
//---------------------------------------------------------------------------

