//---------------------------------------------------------------------------
#ifndef TLinkDialogH
#define TLinkDialogH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------

#include "TNetwork.h"	// to use Nodes
#include "TNode.h"		// to use Nodes->get_id()
#include "TLink.h"


class TLinkDialog : public TForm
{
__published:	// IDE-managed Components
	TBevel *Bevel;

	TLabel *FromLabel;
	TComboBox *Node_a_ComboBox;

	TLabel *ToLabel;
	TComboBox *Node_b_ComboBox;

	TLabel *TypeLabel;
	TComboBox *TypeComboBox;

    TLabel *DelayLabel;
    TScrollBar *DelayScrollBar;
    TLabel *DelayPositionLabel;

    TLabel *CapacityLabel;
    TScrollBar *CapacityScrollBar;
    TLabel *CapacityPositionLabel;
    TLabel *UtilizationLabel;
    TShape *UtilizationShape;
    TLabel *UtilizationPositionLabel;
	TBitBtn *OkBitBtn;
	TBitBtn *CancelBitBtn;


    TLabel *BandwidthLabel;
	void __fastcall Node_a_ComboBoxChange(TObject *Sender);
	void __fastcall Node_b_ComboBoxChange(TObject *Sender);
    void __fastcall TypeComboBoxChange(TObject *Sender);
	void __fastcall DelayScrollBarChange(TObject *Sender);

	void __fastcall CapacityScrollBarChange(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
	void __fastcall OkBitBtnClick(TObject *Sender);

private:	// User declarations

public:		// User declarations
	__fastcall TLinkDialog(TComponent* Owner);

	TLink*		Link;
	int 		node_a_index;
	int 		node_b_index;

    void __fastcall UpdateUtilization(int _utilization);
};
//---------------------------------------------------------------------------
extern TLinkDialog *LinkDialog;
//---------------------------------------------------------------------------
#endif
