//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "About.h"
#include "TMainForm.h"
//---------------------------------------------------------------------------

#include "TMigrationFC.h"
#include "TReplicationFC.h"


//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------





__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
	ActiveChildForm == NULL;
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
	Application->OnHint = ShowHint;
	Screen->OnActiveFormChange = UpdateMenuItems;
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
    FileNewItemClick(Sender);
}

//---------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
	Screen->OnActiveFormChange = NULL;
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::ShowHint(TObject *Sender)
{
	// StatusBar->SimpleText = Application->Hint;
	StatusBar->Panels->Items[StatusBar->Panels->Count - 1]->Text = Application->Hint;
}

//---------------------------------------------------------------------
void __fastcall TMainForm::UpdateMenuItems(TObject *Sender)
{
	EditMenu->Enabled	 				= MDIChildCount > 0;
	RunMenu->Enabled	 				= MDIChildCount > 0;
	WindowCascadeItem->Enabled			= MDIChildCount > 0;
	WindowTileHorizontalItem->Enabled	= MDIChildCount > 0;
	WindowTileVerticalItem->Enabled		= MDIChildCount > 0;
	WindowArrangeIconsItem->Enabled 	= MDIChildCount > 0;
	WindowMinimizeAllItem->Enabled		= MDIChildCount > 0;

	TChildForm* Child = (TChildForm*)ActiveMDIChild;
    if (Child != NULL)
    {
		FileSaveAsItem->Enabled 		= true;
		FileCloseItem->Enabled 			= true;

	    if (TNode::serial_num < MAX_NODES)
        {
    		NetworkAddNodeItem->Enabled		= true;
        }
        else
        {
	    	NetworkAddNodeItem->Enabled		= false;
        }
		NetworkAddLinkItem->Enabled		= true;

		RunStartItem->Enabled			= !Child->Running();
		RunStopItem->Enabled			=  Child->Running();
//        if (!Child->Running())
//        {
//            RunStartSpeedButton->Hint  = "Stopped|";
//            RunStartSpeedButton->Glyph->LoadFromFile("Run.bmp");
//        }


		RunStartSpeedButton->Enabled        = true;
    	SingleFragmentSpeedButton->Enabled	= true;
    	DemandsSpeedButton->Enabled		    = true;
    	soSpeedButton->Enabled		        = true;

    	TNetwork* network = Child->Network;
        if (network != NULL)
        {
	        if (network->IsEmpty())
            {
			  	FileSaveItem->Enabled	= false;
				FilePrintItem->Enabled	= false;
                EditClearItem->Enabled	= false;
            }
            else
            {
			  	FileSaveItem->Enabled	= true;
				FilePrintItem->Enabled	= true;
                EditClearItem->Enabled	= true;
            }
	        if ( Child->NoSelection())
            {
                EditDeleteItem->Enabled	= false;
            }
            else
            {
                EditDeleteItem->Enabled	= true;
            }
	        if ( Child->ToBeUndone())
            {
                EditUndoItem->Enabled	= true;
            }
            else
            {
                EditUndoItem->Enabled	= false;
            }
	        if ( Child->ToBeRedone())
            {
                EditRedoItem->Enabled	= true;
            }
            else
            {
                EditRedoItem->Enabled	= false;
            }
        }
    }
    else // if (Child == NULL)
    {
	  	FileSaveItem->Enabled		= false;
		FilePrintItem->Enabled		= false;
        EditUndoItem->Enabled		= false;
        EditRedoItem->Enabled		= false;
		NetworkAddNodeItem->Enabled	= false;
		NetworkAddLinkItem->Enabled	= false;
        EditDeleteItem->Enabled		= false;
        EditClearItem->Enabled		= false;
		RunStartItem->Enabled		= false;
		RunStopItem->Enabled		= false;

		RunStartSpeedButton->Enabled        = false;
    	SingleFragmentSpeedButton->Enabled	= false;
    	DemandsSpeedButton->Enabled		    = false;
    	soSpeedButton->Enabled		        = false;

    	StatusBar->Panels->Items[0]->Text = "Nodes";
		StatusBar->Panels->Items[1]->Text = "Links";
		StatusBar->Panels->Items[2]->Text = "No Selection";
    }


    FileSaveSpeedButton->Enabled 	= FileSaveItem->Enabled;
	FilePrintSpeedButton->Enabled 	= FilePrintItem->Enabled;
	NetworkAddNodeSpeedButton->Enabled = NetworkAddNodeItem->Enabled;
	NetworkAddLinkSpeedButton->Enabled = NetworkAddLinkItem->Enabled;
	EditUndoSpeedButton->Enabled 	= EditUndoItem->Enabled;
	EditRedoSpeedButton->Enabled 	= EditRedoItem->Enabled;
	EditDeleteSpeedButton->Enabled 	= EditDeleteItem->Enabled;
}


//---------------------------------------------------------------------
void __fastcall TMainForm::MDIChildCreate(String Name)
{
	//--- create a new MDI child window ----
	ActiveChildForm = new TChildForm(Application);
	ActiveChildForm->Caption = Name;
	UpdateMenuItems(NULL);
}


//----------------------------------------------------------------------------
void __fastcall TMainForm::FileNewItemClick(TObject *Sender)
{
	MDIChildCreate("");//"Network" + IntToStr((int)MDIChildCount + 1));
	if (ActiveMDIChild)
		((TChildForm*)ActiveMDIChild)->FileNew();
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::FileOpenItemClick(TObject *Sender)
{
	if (OpenDialog->Execute())
	{
		MDIChildCreate(OpenDialog->FileName);
		if (ActiveMDIChild)
        {
			((TChildForm*)ActiveMDIChild)->FileOpen();
		}
	}
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::FileSaveItemClick(TObject *Sender)
{
	//---- Add code to save current file under current name ----
	if (ActiveMDIChild)
	{
       	((TChildForm*)ActiveMDIChild)->FileSave();
    }
	FileSaveItem->Enabled	= false;
	FileSaveSpeedButton->Enabled = FileSaveItem->Enabled;
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::FileSaveAsItemClick(TObject *Sender)
{
	if (SaveDialog->Execute())
	{
		//--- Add code to save current file under SaveDialog->FileName ---
		if (ActiveMDIChild)
			((TChildForm*)ActiveMDIChild)->FileSaveAs();
	}
	FileSaveItem->Enabled	= false;
	FileSaveSpeedButton->Enabled = FileSaveItem->Enabled;
}

//---------------------------------------------------------------------
void __fastcall TMainForm::FileCloseItemClick(TObject *Sender)
{
	if (ActiveMDIChild)
    {
		((TChildForm*)ActiveMDIChild)->Close();
    }
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::FilePrintItemClick(TObject *Sender)
{
	if (PrintDialog->Execute())
	{
		//---- Add code to print current file ----
		if (ActiveMDIChild)
			((TChildForm*)ActiveMDIChild)->FilePrint();
	}
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::FileExitItemClick(TObject *Sender)
{
	Close();
}




//----------------------------------------------------------------------------
void __fastcall TMainForm::EditUndoItemClick(TObject *Sender)
{
	//---- Add code to perform Edit Undo ----
	if (ActiveMDIChild)
		((TChildForm*)ActiveMDIChild)->EditUndo();
	UpdateMenuItems(NULL);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::EditRedoItemClick(TObject *Sender)
{
	//---- Add code to perform Edit Redo ----
	if (ActiveMDIChild)
		((TChildForm*)ActiveMDIChild)->EditRedo();
	UpdateMenuItems(NULL);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::EditDeleteItemClick(TObject *Sender)
{
	//---- Add code to perform Edit Delete ----
	if (ActiveMDIChild)
		((TChildForm*)ActiveMDIChild)->EditDelete();
	UpdateMenuItems(NULL);
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::EditClearItemClick(TObject *Sender)
{
	//---- Add code to perform Edit Clear ----
	if (ActiveMDIChild)
		((TChildForm*)ActiveMDIChild)->EditClear();
	UpdateMenuItems(NULL);
}


//---------------------------------------------------------------------------
void __fastcall TMainForm::NetworkAddNodeItemClick(TObject *Sender)
{
	//---- Add code to perform NetworkAdd Node ----
	if (ActiveMDIChild)
    	((TChildForm*)ActiveMDIChild)->NetworkAddNode();
	UpdateMenuItems(NULL);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::NetworkAddLinkItemClick(TObject *Sender)
{
	//---- Add code to perform NetworkAdd Link ----
	if (ActiveMDIChild)
    	((TChildForm*)ActiveMDIChild)->NetworkAddLink();
	UpdateMenuItems(NULL);
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::RepositoryDataTypesItemClick(TObject *Sender)
{
	if (ActiveMDIChild)
    	((TChildForm*)ActiveMDIChild)->RepositoryDataTypes();
	UpdateMenuItems(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RepositoryStatisticsItemClick(TObject *Sender)
{
	if (ActiveMDIChild)
    	((TChildForm*)ActiveMDIChild)->RepositoryStatistics();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::DomainPropertiesItemClick(TObject *Sender)
{
	if (ActiveMDIChild)
    	((TChildForm*)ActiveMDIChild)->DomainProperties();
}



//---------------------------------------------------------------------------
void __fastcall TMainForm::RunStartItemClick(TObject *Sender)
{
//    if (ActiveChildForm)
//    {
//		//---- Add code to perform Run Start ----
//		((TChildForm*)ActiveMDIChild)->RunStart();
//		UpdateMenuItems(NULL);
//    }
  if (ActiveChildForm)
  {
    if (AnsiString(RunStartSpeedButton->Hint) == "Stop|")
    {
        RunStartSpeedButton->Hint  = "Run|";
        RunStartSpeedButton->Glyph->LoadFromFile("Run.bmp");
        RunStartSpeedButton->Down = false;
		((TChildForm*)ActiveMDIChild)->RunStop();
    }
    else if (AnsiString(RunStartSpeedButton->Hint) == "Run|")
    {
        RunStartSpeedButton->Hint = "Stop|";
        RunStartSpeedButton->Glyph->LoadFromFile("Stop.bmp");
        RunStartSpeedButton->Down = true;
		((TChildForm*)ActiveMDIChild)->RunStart();
    }
	UpdateMenuItems(NULL);
  }
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::RunStopItemClick(TObject *Sender)
{
//    if (ActiveChildForm)
//    {
//		//---- Add code to perform Run Start ----
//		((TChildForm*)ActiveMDIChild)->RunStop();
//		UpdateMenuItems(NULL);
//    }
}



//---------------------------------------------------------------------------
void __fastcall TMainForm::FrequencyItemClick(TObject *Sender)
{
	if (ActiveMDIChild)
    	((TChildForm*)ActiveMDIChild)->OptionsFrequencies();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::ThresholdsItemClick(TObject *Sender)
{
	if (ActiveMDIChild)
    	((TChildForm*)ActiveMDIChild)->OptionsThresholds();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::MigrationRulesItemClick(TObject *Sender)
{
	if (ActiveMDIChild)
    	((TChildForm*)ActiveMDIChild)->OptionsMigrationRules();
}



//---------------------------------------------------------------------------
void __fastcall TMainForm::ReplicationRulesItemClick(TObject *Sender)
{
	if (ActiveMDIChild)
    	((TChildForm*)ActiveMDIChild)->OptionsReplicationRules();
}




//---------------------------------------------------------------------------
void __fastcall TMainForm::WindowTileHorizontalItemClick(TObject *Sender)
{
	TileMode = tbHorizontal;
	Tile();
}

//---------------------------------------------------------------------------
void __fastcall TMainForm::WindowTileVerticalItemClick(TObject *Sender)
{
	TileMode = tbVertical;
	Tile();
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::WindowCascadeItemClick(TObject *Sender)
{
	Cascade();
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::WindowArrangeIconsItemClick(TObject *Sender)
{
	ArrangeIcons();
}

//---------------------------------------------------------------------
void __fastcall TMainForm::WindowMinimizeAllItemClick(TObject *Sender)
{
	//---- Must be done backwards through the MDIChildren array ----
	for (int i=MDIChildCount-1; i >= 0; i--)
		MDIChildren[i]->WindowState = wsMinimized;
}



//----------------------------------------------------------------------------
void __fastcall TMainForm::HelpContentsItemClick(TObject *Sender)
{
	Application->HelpCommand(HELP_CONTENTS, 0);
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::HelpSearchItemClick(TObject *Sender)
{
	Application->HelpCommand(HELP_PARTIALKEY, Longint(""));
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::HelpHowToUseItemClick(TObject *Sender)
{
	Application->HelpCommand(HELP_HELPONHELP, 0);
}

//----------------------------------------------------------------------------
void __fastcall TMainForm::HelpAboutItemClick(TObject *Sender)
{
	//---- Add code to show program's About Box ----
    AboutBox->ShowModal();
}
//---------------------------------------------------------------------------








//---------------------------------------------------------------------------
void __fastcall TMainForm::SingleFragmentSpeedButtonClick(TObject *Sender)
{
  if (ActiveChildForm)
  {
    if (AnsiString(SingleFragmentSpeedButton->Hint) == "Single Fragment|")
    {
        OptionsFragmentItem->Caption = "Single &Fragment";
        SingleFragmentSpeedButton->Hint  = "Multi-Fragment|";
        SingleFragmentSpeedButton->Down  = true;
        SingleFragmentSpeedButton->Glyph->LoadFromFile("Fragments.bmp");
		((TChildForm*)ActiveMDIChild)->single_fragment = false;
    }
    else if (AnsiString(SingleFragmentSpeedButton->Hint) == "Multi-Fragment|")
    {
        OptionsFragmentItem->Caption = "Multi &Fragment";
        SingleFragmentSpeedButton->Hint = "Single Fragment|";
        SingleFragmentSpeedButton->Down  = false;
        SingleFragmentSpeedButton->Glyph->LoadFromFile("Fragment.bmp");
		((TChildForm*)ActiveMDIChild)->single_fragment = true;
    }
  }
}


//---------------------------------------------------------------------------
void __fastcall TMainForm::DemandsSpeedButtonClick(TObject *Sender)
{
  if (ActiveChildForm)
  {
    if (AnsiString(DemandsSpeedButton->Hint) == "Manual Demands|")
    {
        OptionsDemandItem->Caption = "Manual &Demands";
        DemandsSpeedButton->Hint  = "Auto Demands|";
        DemandsSpeedButton->Down  = true;
        DemandsSpeedButton->Glyph->LoadFromFile("Auto.bmp");
		((TChildForm*)ActiveMDIChild)->auto_demands = true;
    }
    else if (AnsiString(DemandsSpeedButton->Hint) == "Auto Demands|")
    {
        OptionsDemandItem->Caption = "Auto &Demands";
        DemandsSpeedButton->Hint = "Manual Demands|";
        DemandsSpeedButton->Down  = false;
        DemandsSpeedButton->Glyph->LoadFromFile("Manual.bmp");
		((TChildForm*)ActiveMDIChild)->auto_demands = false;
    }
  }
}


//---------------------------------------------------------------------------
void __fastcall TMainForm::SameClusterDemandsSpeedButtonClick(TObject *Sender)
{
  if (ActiveChildForm)
  {
	((TChildForm*)ActiveMDIChild)->same_demands_on_clusters = !((TChildForm*)ActiveMDIChild)->same_demands_on_clusters;

    if (AnsiString(SameClusterDemandsSpeedButton->Hint) == "Same Cluster Demands|Same demands on Clusters within each Fragment")
    {
        SameClusterDemandsSpeedButton->Down = true;
        OptionsClusterDemandsItem->Caption = "Same &Cluster Demands";
        SameClusterDemandsSpeedButton->Hint = "Different Cluster Demands|Different demands on Clusters within each Fragment";
        SameClusterDemandsSpeedButton->Glyph->LoadFromFile("DifferentDemands.bmp");
    }
    else if (AnsiString(SameClusterDemandsSpeedButton->Hint) == "Different Cluster Demands|Different demands on Clusters within each Fragment")
    {
        SameClusterDemandsSpeedButton->Down = false;
        OptionsClusterDemandsItem->Caption = "Different &Cluster Demands";
        SameClusterDemandsSpeedButton->Hint = "Same Cluster Demands|Same demands on Clusters within each Fragment";
        SameClusterDemandsSpeedButton->Glyph->LoadFromFile("SameDemands.bmp");
    }
  }
}



//---------------------------------------------------------------------------
void __fastcall TMainForm::soSpeedButtonClick(TObject *Sender)
{
  if (ActiveChildForm)
  {
    if (AnsiString(soSpeedButton->Hint) == "Enable Self-Organization|")
    {
        OptionsSelfOrganizationItem->Caption = "Disable &Self-Organization";
        soSpeedButton->Hint  = "Disable Self-Organization|";
        soSpeedButton->Down  = true;
        soSpeedButton->Glyph->LoadFromFile("soEnabled.bmp");
		((TChildForm*)ActiveMDIChild)->RunEnableSO();
    }
    else if (AnsiString(soSpeedButton->Hint) == "Disable Self-Organization|")
    {
        OptionsSelfOrganizationItem->Caption = "Enable &Self-Organization";
        soSpeedButton->Hint = "Enable Self-Organization|";
        soSpeedButton->Down  = false;
        soSpeedButton->Glyph->LoadFromFile("soDisabled.bmp");
		((TChildForm*)ActiveMDIChild)->RunDisableSO();
    }
  }
}


void __fastcall TMainForm::PartitioningSpeedButtonClick(TObject *Sender)
{
  if (ActiveChildForm)
  {
	((TChildForm*)ActiveMDIChild)->p_enabled = !((TChildForm*)ActiveMDIChild)->p_enabled;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::MigrationSpeedButtonClick(TObject *Sender)
{
  if (ActiveChildForm)
  {
	((TChildForm*)ActiveMDIChild)->m_enabled = !((TChildForm*)ActiveMDIChild)->m_enabled;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CombiningSpeedButtonClick(TObject *Sender)
{
  if (ActiveChildForm)
  {
	((TChildForm*)ActiveMDIChild)->c_enabled = !((TChildForm*)ActiveMDIChild)->c_enabled;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ReplicationSpeedButtonClick(TObject *Sender)
{
  if (ActiveChildForm)
  {
	((TChildForm*)ActiveMDIChild)->r_enabled = !((TChildForm*)ActiveMDIChild)->r_enabled;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DestructionSpeedButtonClick(TObject *Sender)
{
  if (ActiveChildForm)
  {
	((TChildForm*)ActiveMDIChild)->d_enabled = !((TChildForm*)ActiveMDIChild)->d_enabled;
  }
}
//---------------------------------------------------------------------------







void __fastcall TMainForm::ReplicationLevelTrackBarChange(TObject *Sender)
{
    ReplicationLevelValueLabel->Caption = ReplicationLevelTrackBar->Position;
    TReplicationFC::ReplicationThreshold = 100 - ReplicationLevelTrackBar->Position;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::UpdateRatioTrackBarChange(TObject *Sender)
{
    UpdateRatioValueLabel->Caption = UpdateRatioTrackBar->Position;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ReplicaSynchronizationTrackBarChange(TObject *Sender)
{
    ReplicaSynchronizationValueLabel->Caption = ReplicaSynchronizationTrackBar->Position;
}
//---------------------------------------------------------------------------


