//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <vcl\sysutils.hpp>
#include <vcl\windows.hpp>
#include <vcl\messages.hpp>
#include <vcl\sysutils.hpp>
#include <vcl\classes.hpp>
#include <vcl\graphics.hpp>
#include <vcl\controls.hpp>
#include <vcl\forms.hpp>
#include <vcl\dialogs.hpp>
#include <vcl\stdctrls.hpp>
#include <vcl\buttons.hpp>
#include <vcl\extctrls.hpp>
#include <vcl\menus.hpp>
#include <vcl\ComCtrls.hpp>
#include <Buttons.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>

/*
#include "TData.h"
#include "TCluster.h"
#include "TFragment.h"

#include "TNode.h"
#include "TLink.h"
#include "TNetwork.h"

#include "TNodeDialog.h"
#include "TLinkDialog.h"
#include "TMigrationForm.h"
*/

#include "TChildForm.h"
#include <StdCtrls.hpp>


//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TMainMenu *MainMenu;
	TMenuItem *FileMenu;
	TMenuItem *FileNewItem;
	TMenuItem *FileOpenItem;
	TMenuItem *FileSaveItem;
	TMenuItem *FileSaveAsItem;
	TMenuItem *FileCloseItem;
	TMenuItem *FilePrintItem;
	TMenuItem *FileExitItem;
	TMenuItem *EditMenu;
	TMenuItem *EditUndoItem;
	TMenuItem *EditRedoItem;
	TMenuItem *EditDeleteItem;
	TMenuItem *EditClearItem;
	TMenuItem *NetworkMenu;
	TMenuItem *NetworkAddNodeItem;
	TMenuItem *NetworkAddLinkItem;
	TMenuItem *RepositoryMenu;
	TMenuItem *RepositoryDataTypesItem;
	TMenuItem *RunMenu;
	TMenuItem *RunStartItem;
	TMenuItem *RunStopItem;
	TMenuItem *OptionsMenu;
    TMenuItem *FrequencyItem;
	TMenuItem *WindowMenu;
	TMenuItem *WindowTileHorizontalItem;
	TMenuItem *WindowTileVerticalItem;
	TMenuItem *WindowCascadeItem;
	TMenuItem *WindowArrangeIconsItem;
	TMenuItem *WindowMinimizeAllItem;
	TMenuItem *HelpMenu;
	TMenuItem *HelpAboutItem;

	TOpenDialog *OpenDialog;
	TSaveDialog *SaveDialog;
	TPrintDialog *PrintDialog;
	TPanel *SpeedBar;
	TSpeedButton *FileNewSpeedButton;
	TSpeedButton *FileOpenSpeedButton;
	TSpeedButton *FileSaveSpeedButton;
	TSpeedButton *FilePrintSpeedButton;
	TSpeedButton *NetworkAddNodeSpeedButton;
	TSpeedButton *NetworkAddLinkSpeedButton;
	TSpeedButton *EditUndoSpeedButton;
	TSpeedButton *EditDeleteSpeedButton;
	TSpeedButton *EditRedoSpeedButton;
	TSpeedButton *RunStartSpeedButton;
	TSpeedButton *HelpAboutSpeedButton;

	TStatusBar *StatusBar;

    TSpeedButton *soSpeedButton;
    TSpeedButton *DemandsSpeedButton;
    TSpeedButton *SingleFragmentSpeedButton;
    TMenuItem *OptionsFragmentItem;
    TMenuItem *OptionsDemandItem;
    TMenuItem *OptionsSelfOrganizationItem;
    TMenuItem *ThresholdsItem;
    TMenuItem *N5;
    TMenuItem *N8;
    TMenuItem *MigrationRulesItem;
    TMenuItem *ReplicationRulesItem;
    TSpeedButton *PartitioningSpeedButton;
    TSpeedButton *MigrationSpeedButton;
    TSpeedButton *CombiningSpeedButton;
    TSpeedButton *ReplicationSpeedButton;
    TSpeedButton *DestructionSpeedButton;
    TSpeedButton *SameClusterDemandsSpeedButton;
    TMenuItem *OptionsClusterDemandsItem;
    TTrackBar *ReplicationLevelTrackBar;
    TTrackBar *ReplicaSynchronizationTrackBar;
    TLabel *ReplicationLevelLabel;
    TLabel *ReplicaSynchronizationLabel;
    TLabel *ReplicationLevelValueLabel;
    TLabel *ReplicaSynchronizationValueLabel;
    TLabel *rlPercentLabel;
    TLabel *rsPercentLabel;
    TLabel *Label1;
    TLabel *Label2;
    TTrackBar *TrackBar1;
    TLabel *Label4;
    TLabel *UpdateRatioLabel;
    TTrackBar *UpdateRatioTrackBar;
    TLabel *UpdateRatioValueLabel;
    TLabel *urLabel;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
	void __fastcall ShowHint(TObject *Sender);
	void __fastcall UpdateMenuItems(TObject *Sender);

	void __fastcall FileNewItemClick(TObject *Sender);
	void __fastcall FileOpenItemClick(TObject *Sender);
	void __fastcall FileSaveItemClick(TObject *Sender);
	void __fastcall FileSaveAsItemClick(TObject *Sender);
	void __fastcall FileCloseItemClick(TObject *Sender);
	void __fastcall FilePrintItemClick(TObject *Sender);
	void __fastcall FileExitItemClick(TObject *Sender);
	void __fastcall EditUndoItemClick(TObject *Sender);
	void __fastcall EditRedoItemClick(TObject *Sender);
	void __fastcall EditDeleteItemClick(TObject *Sender);
	void __fastcall EditClearItemClick(TObject *Sender);
	void __fastcall NetworkAddNodeItemClick(TObject *Sender);
	void __fastcall NetworkAddLinkItemClick(TObject *Sender);
	void __fastcall RepositoryDataTypesItemClick(TObject *Sender);
	void __fastcall RepositoryStatisticsItemClick(TObject *Sender);
	void __fastcall DomainPropertiesItemClick(TObject *Sender);
	void __fastcall RunStartItemClick(TObject *Sender);
	void __fastcall RunStopItemClick(TObject *Sender);
	void __fastcall FrequencyItemClick(TObject *Sender);
	void __fastcall WindowTileHorizontalItemClick(TObject *Sender);
	void __fastcall WindowTileVerticalItemClick(TObject *Sender);
	void __fastcall WindowCascadeItemClick(TObject *Sender);
	void __fastcall WindowArrangeIconsItemClick(TObject *Sender);
	void __fastcall WindowMinimizeAllItemClick(TObject *Sender);
	void __fastcall HelpContentsItemClick(TObject *Sender);
	void __fastcall HelpSearchItemClick(TObject *Sender);
	void __fastcall HelpHowToUseItemClick(TObject *Sender);
	void __fastcall HelpAboutItemClick(TObject *Sender);

    void __fastcall soSpeedButtonClick(TObject *Sender);
    void __fastcall DemandsSpeedButtonClick(TObject *Sender);
    void __fastcall SingleFragmentSpeedButtonClick(TObject *Sender);
    

    void __fastcall ThresholdsItemClick(TObject *Sender);
    void __fastcall MigrationRulesItemClick(TObject *Sender);
    void __fastcall ReplicationRulesItemClick(TObject *Sender);
    void __fastcall PartitioningSpeedButtonClick(TObject *Sender);
    void __fastcall MigrationSpeedButtonClick(TObject *Sender);
    void __fastcall CombiningSpeedButtonClick(TObject *Sender);
    void __fastcall ReplicationSpeedButtonClick(TObject *Sender);
    void __fastcall DestructionSpeedButtonClick(TObject *Sender);
    
    
    void __fastcall SameClusterDemandsSpeedButtonClick(TObject *Sender);
    void __fastcall ReplicationLevelTrackBarChange(TObject *Sender);
    void __fastcall ReplicaSynchronizationTrackBarChange(TObject *Sender);
    void __fastcall UpdateRatioTrackBarChange(TObject *Sender);
private:        // private user declarations

public:         // public user declarations
	virtual __fastcall TMainForm(TComponent* Owner);

	TChildForm 	*ActiveChildForm;
	void __fastcall MDIChildCreate(const String Name);
};
//---------------------------------------------------------------------------
extern TMainForm* MainForm;
//---------------------------------------------------------------------------
#endif
