//---------------------------------------------------------------------------
#ifndef NetworkH
#define NetworkH
//---------------------------------------------------------------------------

#include "TNode.h"
#include "TLink.h"


class TNetwork
{
	private:
    	int      	id;
        int			selected_node_index;
        int			selected_link_index;

    public:
	    int         neighbours     [MAX_NODES][MAX_NODES];
	    int         delays         [MAX_NODES][MAX_NODES];
	    int         intermediates  [MAX_NODES][MAX_NODES][MAX_NODES];   // intermediate_node_indexes
	    TList*      shortest_paths [MAX_NODES][MAX_NODES];              // intermediate_links
        void        calculate_shortest_paths();

        int         info_type; // draw
                               //     0   none,
                               //     1   neighbours,
                               //     2   delays,
                               //     3   intermediate nodes,
                               //     4   intermediate links

    public:
		TList*    	Nodes;
		TList*    	Links;

	    int			CPUCapacity;
	    int			MEMCapacity;
	    int			IOCapacity;
    	int			STOCapacity;
	    int			COMCapacity;
        int			TOTALCapacity;
	    TList*		ResourceUsageHistory;
        int         minResource;
        int         maxResource;
	    TList*		ResponseTimeHistory;
        int         minResponse;
        int         maxResponse;


    	TNetwork();
    	TNetwork(TNetwork* _Network);
    	~TNetwork();

        void update_links_utilization();

		void set_id(int _id)	   { id  = _id;}
        void set_selected_node_index(int _index)		{ selected_node_index = _index; }
        void set_selected_link_index(int _index)		{ selected_link_index = _index; }

		int  get_id()						{ return id;}
		int  get_selected_node_index()   	{ return selected_node_index;}
		int  get_selected_link_index()   	{ return selected_link_index;}

		TNode* GetNode(int id);
		TNode* AddNode(int x=100, int y=100);
		TLink* AddLink(TNode* _node_a, TNode* _node_b);
		TNode* AddFullyConnectedNode(int x=100, int y=100);
		void DeleteNodeAndItsLinks(int _index);
		void DeleteLink(int _index);
		bool IsEmpty();
		void Clear();

		void Draw(TCanvas* _canvas);

		void DeSelectChildren();
        bool AnySelection();
};
//---------------------------------------------------------------------------
#endif
