//---------------------------------------------------------------------------
#ifndef TNodeH
#define TNodeH
//---------------------------------------------------------------------------
#include <vcl\Graphics.hpp>

#include <stdlib.h>     // int random(int);
//---------------------------------------------------------------------------


#define MAX_FULL_SIZE_FRAGMENTS_PER_NODE                    10  // storage    capacity
#define MAX_FULLY_DEMANDED_FULL_SIZE_FRAGMNETS_PER_NODE     10  // processing capacity



class TNetwork;
#include "TLink.h"
#include "TFragment.h"


#define PROCESSOR_CAPACITY_FACTOR   		0.60
#define STORAGE_CAPACITY_FACTOR             0.40

#define PROCESSOR_UTILIZATION_FACTOR		0.60
#define STORAGE_UTILIZATION_FACTOR			0.40



class TNode
{
    public:
		static int	scale;
		static int	serial_num;
			   int	fragment_serial_num;

        // drawing area dimensions for any node
        static int  area_width;
        static int  area_height;
        // drawing area left_top for this node
               int  area_left;
    	       int  area_top;
    	void   calculate_area_lefttop();	// as node_index changes in Network->Nodes 


    private:
		int      id;
		TPoint   position;

		int      num_of_processors;
		int      processor_capacity;
		float    processor_utilization;
		int      storage_capacity;
		float    storage_utilization;

		int      capacity;		int      radius;
		float    utilization;	TColor   color;

        bool	 selected;
        TColor   selection_color;
		int		 selected_fragment_index;
		int      connectivity;

	public:
		TNetwork*		Network;
	    TList*			Links;
		TList*			Fragments;

	    TNode(TNode* _node);
	    TNode(TNetwork* _Network, TPoint _position);
	    virtual ~TNode();

        void get_neighbours(int neighbours[]);

		int      get_id() 		     	{ return id;}
		TPoint	 get_position()    		{ return position; }

		int      get_num_of_processors()      	{ return num_of_processors;}
		int      get_processor_capacity()      	{ return processor_capacity;}
        float	 get_processor_utilization()	{ return processor_utilization; }
		int      get_storage_capacity()        	{ return storage_capacity;}
        float	 get_storage_utilization()		{ return storage_utilization; }

		int      get_capacity()        	{ return capacity;}
		int      get_radius()        	{ return radius;}
        float	 get_utilization()		{ return utilization; }
        TColor   get_color()    	    { return color;}
		int  	 get_selected_fragment_index()	{ return selected_fragment_index;}

        int 	 get_connectivity()		{ return update_connectivity(); }


		void set_id(int _id)	               				{ id  = _id;}
		void set_position(TPoint _position)    				{ position = _position; }

		void set_num_of_processors(int _num_of_processors)  { num_of_processors = _num_of_processors; }
		void set_processor_capacity(int _capacity)          { processor_capacity = _capacity; }
        void set_processor_utilization(float _utilization)  { processor_utilization = _utilization; }
		void set_storage_capacity(int _capacity)            { storage_capacity = _capacity; }
        void set_storage_utilization(float _utilization)    { storage_utilization = _utilization; }

    	void  update_capacity();
		float update_utilization();
   		int   update_connectivity();

        void set_selected_fragment_index(int _index)		{ selected_fragment_index = _index; }

       	void AddFragment(TFragment* _Fragment);
       	TFragment* DeleteFragment(int _index, int _Owner = true);
		TFragment* RemoveFragment(TFragment* _Fragment, int _Owner = false);

		void Draw(TCanvas* _canvas);
		void DrawCaption(TCanvas* _canvas);
		void DrawDetails(TCanvas* _canvas);

		bool IsSelected();
	    void Select(TColor _selection_color);
	    void DeSelect();
	    void DeSelectChildren();
        bool AnySelection();
};


//---------------------------------------------------------------------------
#endif