//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <math.h>
#pragma hdrstop


#include "functions.h"
#include "TNodeDialog.h"


//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNodeDialog *NodeDialog;
//---------------------------------------------------------------------------
__fastcall TNodeDialog::TNodeDialog(TComponent* Owner)
	: TForm(Owner)
{
	Node			= NULL;
	new_fragments	= 0;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TNodeDialog::AddNewFragmentBitBtnClick(TObject *Sender)
{
    new_fragments++;
    FragmentsCountLabel->Caption = IntToStr((int)StrToInt(FragmentsCountLabel->Caption) + 1);
    if ((Node->fragment_serial_num + new_fragments) == MAX_FULL_SIZE_FRAGMENTS_PER_NODE)
    {
    	AddNewFragmentBitBtn->Enabled = false;
    }
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void __fastcall TNodeDialog::AddNewLinkBitBtnClick(TObject *Sender)
{
	    if (Node->Network != NULL && Node->Network->Nodes->Count >= 2)
    	{
   		    LinkDialog->Link = NULL; // just used for initial values

			LinkDialog->node_a_index = Node->Network->Nodes->IndexOf(Node);
			LinkDialog->node_b_index = -1;

			LinkDialog->Node_a_ComboBox->Clear();
		    for(int i=0; i<Node->Network->Nodes->Count; i++)
	    	{
				LinkDialog->Node_a_ComboBox->Items->Add(IntToStr((int) ((TNode*)Node->Network->Nodes->Items[i])->get_id() ));
			}
			LinkDialog->Node_a_ComboBox->ItemIndex = LinkDialog->node_a_index;
	    	LinkDialog->Node_a_ComboBox->Enabled = false;

			LinkDialog->Node_b_ComboBox->Clear();
    		for(int i=0; i<Node->Network->Nodes->Count; i++)
	    	{
				LinkDialog->Node_b_ComboBox->Items->Add(IntToStr((int) ((TNode*)Node->Network->Nodes->Items[i])->get_id() ));
			}
			LinkDialog->Node_b_ComboBox->ItemIndex = LinkDialog->node_b_index;
    		LinkDialog->Node_b_ComboBox->Enabled = true;

			LinkDialog->TypeComboBox->ItemIndex = -1;
		    LinkDialog->DelayScrollBar->Position 		=  5;
	    	LinkDialog->CapacityScrollBar->Position 	= 50;

			if (LinkDialog->ShowModal() == mrOk)
            {
			  int node_a_index = LinkDialog->node_a_index;
			  int node_b_index = LinkDialog->node_b_index;
			  if ( (node_a_index != -1) && (node_b_index != -1) )
              {
                TNode* node_a = (TNode*)(Node->Network->Nodes->Items[node_a_index]);
			    TNode* node_b = (TNode*)(Node->Network->Nodes->Items[node_b_index]);

	        	TLink* added_link = Node->Network->AddLink(node_a, node_b);

	        	added_link->set_type(LinkDialog->TypeComboBox->ItemIndex);
	        	added_link->set_initial_delay(LinkDialog->DelayScrollBar->Position);
	        	added_link->set_capacity(LinkDialog->CapacityScrollBar->Position);

			    LinksCountLabel->Caption = IntToStr((int)StrToInt(LinksCountLabel->Caption) + 1);
              }
            }
    	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void __fastcall TNodeDialog::ProcessorCapacityScrollBarChange(TObject *Sender)
{
	ProcessorCapacityPositionLabel->Caption = AnsiString(ProcessorCapacityScrollBar->Position) + AnsiString("%");
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
void __fastcall TNodeDialog::UpdateProcessorUtilization(int _utilization)
{
//    if (_utilization ==  0) _utilization =   0;
//    if (_utilization > 100) _utilization = 100;
	if (_utilization < 50)	//  0 .. 50
    {
       ProcessorUtilizationShape->Brush->Color	= (TColor) RGB(
   											255,
	                            	        255 - (_utilization*2)*2.55,
	                                	    255
	            						  );
    }
    else	//  50 .. 100
    {
       ProcessorUtilizationShape->Brush->Color	= (TColor) RGB(
	            							((100-_utilization)*2)*2.55,
       				            	        0,
                       					    ((100-_utilization)*2)*2.55
	            						  );
    }

	ProcessorUtilizationPositionLabel->Caption = AnsiString(_utilization) + AnsiString("%");
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void __fastcall TNodeDialog::StorageCapacityScrollBarChange(TObject *Sender)
{
	StorageCapacityPositionLabel->Caption = AnsiString(StorageCapacityScrollBar->Position) + AnsiString("%");
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
void __fastcall TNodeDialog::UpdateStorageUtilization(int _utilization)
{
//    if (_utilization ==  0) _utilization =   0;
//    if (_utilization > 100) _utilization = 100;
	if (_utilization < 50)	//  0 .. 50
    {
       StorageUtilizationShape->Brush->Color	= (TColor) RGB(
   											255,
	                            	        255 - (_utilization*2)*2.55,
	                                	    255
	            						  );
    }
    else	//  50 .. 100
    {
       StorageUtilizationShape->Brush->Color	= (TColor) RGB(
	            							((100-_utilization)*2)*2.55,
       				            	        0,
                       					    ((100-_utilization)*2)*2.55
	            						  );
    }

	StorageUtilizationPositionLabel->Caption = AnsiString(_utilization) + AnsiString("%");
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
void __fastcall TNodeDialog::FormShow(TObject *Sender)
{
	if (Node != NULL)
    {
	    IdEdit->Text = Node->get_id();
	   	if (Node->fragment_serial_num < MAX_FULL_SIZE_FRAGMENTS_PER_NODE)
        {
        	AddNewFragmentBitBtn->Enabled = true;
        }
        else
        {
        	AddNewFragmentBitBtn->Enabled = false;
        }

	    FragmentsCountLabel->Caption = IntToStr((int)Node->Fragments->Count);
	    LinksCountLabel->Caption = IntToStr((int)Node->Links->Count);

	    NumberOfProcessorsEdit->Text = IntToStr((int)Node->get_num_of_processors());

	    NumberOfProcessorsUpDown->Position = logx(Node->get_num_of_processors(), 2);
	    ProcessorCapacityScrollBar->Position = Node->get_processor_capacity();
        UpdateProcessorUtilization(Node->get_processor_utilization());
	    StorageCapacityScrollBar->Position = Node->get_storage_capacity();
        UpdateStorageUtilization(Node->get_storage_utilization());
    }
}
//---------------------------------------------------------------------------
void __fastcall TNodeDialog::OkBitBtnClick(TObject *Sender)
{
	if (Node != NULL)
    {
	    //Node->set_num_of_processors(StrToInt(NumberOfProcessorsEdit->Text));
	    Node->set_num_of_processors(pow(2, NumberOfProcessorsUpDown->Position));
	    Node->set_processor_capacity(ProcessorCapacityScrollBar->Position);
	    Node->set_storage_capacity(StorageCapacityScrollBar->Position);
	    Node->update_capacity();

       	for (int i=0; i<new_fragments; i++)
        {
			TFragment* Fragment = new TFragment(Node);
		    Node->AddFragment(Fragment);
        }
    }

    Node->update_utilization();

	new_fragments	= 0;
}
//---------------------------------------------------------------------------


void __fastcall TNodeDialog::NumberOfProcessorsUpDownClick(TObject *Sender, TUDBtnType Button)
{
    NumberOfProcessorsEdit->Text = IntToStr((int) pow(2, NumberOfProcessorsUpDown->Position) );
}
//---------------------------------------------------------------------------

