//---------------------------------------------------------------------------
#ifndef TNodeDialogH
#define TNodeDialogH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------

#include "TNode.h"
#include "TLink.h"
#include "TNetwork.h"
#include "TLinkDialog.h"
#include "cspin.h"
#include <ComCtrls.hpp>



class TNodeDialog : public TForm
{
__published:	// IDE-managed Components
	TBevel *Bevel;

	TLabel *IdLabel;
	TEdit *IdEdit;

	TLabel *FragmentsLabel;
	TBitBtn *AddNewFragmentBitBtn;
	TLabel *FragmentsCountLabel;

	TLabel *LinksLabel;
	TBitBtn *AddNewLinkBitBtn;
	TLabel *LinksCountLabel;

    TLabel *ProcessorLabel;
    TLabel *ProcessorCapacityLabel;
    TScrollBar *ProcessorCapacityScrollBar;
    TLabel *ProcessorCapacityPositionLabel;
    TLabel *ProcessorUtilizationLabel;
    TShape *ProcessorUtilizationShape;
    TLabel *ProcessorUtilizationPositionLabel;

    TLabel *StorageLabel;
    TLabel *StorageCapacityLabel;
    TScrollBar *StorageCapacityScrollBar;
    TLabel *StorageCapacityPositionLabel;
    TLabel *StorageUtilizationLabel;
    TShape *StorageUtilizationShape;
    TLabel *StorageUtilizationPositionLabel;


	TBitBtn *OkBitBtn;
	TBitBtn *CancelBitBtn;

    TLabel *NumberOfProcessorsLabel;
    TUpDown *NumberOfProcessorsUpDown;
    TEdit *NumberOfProcessorsEdit;
	void __fastcall AddNewFragmentBitBtnClick(TObject *Sender);
	void __fastcall AddNewLinkBitBtnClick(TObject *Sender);

    void __fastcall ProcessorCapacityScrollBarChange(TObject *Sender);
    void __fastcall StorageCapacityScrollBarChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall OkBitBtnClick(TObject *Sender);

    void __fastcall NumberOfProcessorsUpDownClick(TObject *Sender,
          TUDBtnType Button);
private:	// User declarations
	int		new_fragments;

public:		// User declarations
	__fastcall TNodeDialog(TComponent* Owner);
    TNode*		Node;

    void __fastcall UpdateProcessorUtilization(int _utilization);
    void __fastcall UpdateStorageUtilization(int _utilization);
};
//---------------------------------------------------------------------------
extern TNodeDialog *NodeDialog;
//---------------------------------------------------------------------------
#endif
