//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

USERES("soData.res");
USEUNIT("functions.cpp");
USEUNIT("TFuzzySet.cpp");
USEUNIT("TFuzzyRule.cpp");
USEUNIT("TFuzzyController.cpp");
USEUNIT("TFuzzySystem.cpp");
USEUNIT("TData.cpp");
USEUNIT("TCluster.cpp");
USEUNIT("TFragment.cpp");
USEUNIT("TNode.cpp");
USEUNIT("TLink.cpp");
USEUNIT("TNetwork.cpp");
USEFORM("TMainForm.cpp", MainForm);
USEFORM("TChildForm.cpp", ChildForm);
USEFORM("About.cpp", AboutBox);
USEFORM("TNodeDialog.cpp", NodeDialog);
USEFORM("TLinkDialog.cpp", LinkDialog);
USEFORM("TFrequenciesDialog.cpp", FrequenciesDialog);
USEFORM("TThresholdsDialog.cpp", ThresholdsDialog);
USEFORM("TMigrationForm.cpp", MigrationForm);
USEFORM("TReplicationForm.cpp", ReplicationForm);
USEUNIT("TMigrationFC.cpp");
USEUNIT("TReplicationFC.cpp");
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    try
    {
        Application->Initialize();
        Application->HelpFile = "soData.hlp";
        Application->Title = "Self Organizing Data";
        Application->CreateForm(__classid(TMainForm), &MainForm);
        Application->CreateForm(__classid(TAboutBox), &AboutBox);
        Application->CreateForm(__classid(TLinkDialog), &LinkDialog);
        Application->CreateForm(__classid(TFrequenciesDialog), &FrequenciesDialog);
        Application->CreateForm(__classid(TThresholdsDialog), &ThresholdsDialog);
        Application->CreateForm(__classid(TMigrationForm), &MigrationForm);
        Application->CreateForm(__classid(TReplicationForm), &ReplicationForm);
        Application->CreateForm(__classid(TNodeDialog), &NodeDialog);
        Application->Run();
    }
    catch (Exception &exception)
    {
        Application->ShowException(&exception);
    }
    return 0;
}
//---------------------------------------------------------------------------

